Xalan-Java 2.7.1: Class SerializerBase

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.xml.serializer
Class SerializerBase

    java.lang.Object
      |
      +--org.apache.xml.serializer.SerializerBase

Direct Known Subclasses:
  ToSAXHandler, ToStream, ToUnknownStream

public abstract class SerializerBase
extends java.lang.Object
implements SerializationHandler, org.apache.xml.serializer.SerializerConstants

This class acts as a base class for the XML "serializers" and the stream serializers. It contains a number of common fields and methods.

Usage:
  **For internal use only**

Field Summary
`static java.lang.String` | `PKG_NAME` The name of the package that this class is in.
`static java.lang.String` | `PKG_PATH` The same as the name of the package that this class is in except that '.' are replaced with '/'.

Method Summary
`void` | `addAttribute(java.lang.String name, java.lang.String value)` Adds the given attribute to the set of collected attributes, but only if there is a currently open element.
`void` | `addAttribute(java.lang.String uri, java.lang.String localName, java.lang.String rawName, java.lang.String type, java.lang.String value)` This method adds an attribute the the current element, but should not be used for an xsl:attribute child.
`void` | `addAttribute(java.lang.String uri, java.lang.String localName, java.lang.String rawName, java.lang.String type, java.lang.String value, boolean XSLAttribute)` Adds the given attribute to the set of collected attributes , but only if there is a currently open element.
`boolean` | `addAttributeAlways(java.lang.String uri, java.lang.String localName, java.lang.String rawName, java.lang.String type, java.lang.String value, boolean XSLAttribute)` Adds the given attribute to the set of attributes, even if there is no currently open element.
`void` | `addAttributes(Attributes atts)` Add the given attributes to the currently collected ones.
`void` | `addXSLAttribute(java.lang.String name, java.lang.String value, java.lang.String uri)` Adds the given xsl:attribute to the set of collected attributes, but only if there is a currently open element.
`ContentHandler` | `asContentHandler()` Return a `ContentHandler` interface into this serializer.
`java.lang.Object` | `asDOM3Serializer()` Return a `DOM3Serializer` interface into this serializer.
`DOMSerializer` | `asDOMSerializer()` Return a `DOMSerializer` interface into this serializer.
`void` | `characters(Node node)` This method gets the nodes value as a String and uses that String as if it were an input character notification.
`void` | `close()` Flush and close the underlying java.io.Writer.
`void` | `comment(java.lang.String data)` Receive notification of a comment.
`boolean` | `documentIsEmpty()` Return true if nothing has been sent to this result tree yet.
`void` | `endEntity(java.lang.String name)` Report the end of an entity.
`void` | `entityReference(java.lang.String name)` Entity reference event.
`void` | `error(SAXParseException exc)`
`void` | `fatalError(SAXParseException exc)`
`void` | `fireEndEntity(java.lang.String name)` To fire off end entity trace event
`java.lang.String` | `getDoctypePublic()` Returns the previously set value of the value to be used as the public identifier in the document type declaration (DTD).
`java.lang.String` | `getDoctypeSystem()` Returns the previously set value of the value to be used as the system identifier in the document type declaration (DTD).
`java.lang.String` | `getEncoding()` Returns the character encoding to be used in the output document.
`boolean` | `getIndent()`
`int` | `getIndentAmount()`
`java.lang.String` | `getMediaType()` Gets the mediatype the media-type or MIME type associated with the output document.
`NamespaceMappings` | `getNamespaceMappings()` Some users of the serializer may need the current namespace mappings
`java.lang.String` | `getNamespaceURI(java.lang.String qname, boolean isElement)` Returns the URI of an element or attribute.
`java.lang.String` | `getNamespaceURIFromPrefix(java.lang.String prefix)` Returns the URI of prefix (if any)
`boolean` | `getOmitXMLDeclaration()`
`java.lang.String` | `getOutputProperty(java.lang.String name)` Get the value of an output property, the explicit value, if any, otherwise the default value, if any, otherwise null.
`java.lang.String` | `getOutputPropertyDefault(java.lang.String name)` Get the default value of an xsl:output property, which would be null only if no default value exists for the property.
`java.lang.String` | `getOutputPropertyNonDefault(java.lang.String name)` Get the value of an output property, not the default value.
`java.lang.String` | `getPrefix(java.lang.String namespaceURI)` Returns the prefix currently pointing to the given URI (if any).
`java.lang.String` | `getStandalone()` Gets the XSL standalone attribute
`Transformer` | `getTransformer()` Gets the transformer associated with this serializer
`java.lang.String` | `getVersion()` Gets the version of the output format.
`void` | `namespaceAfterStartElement(java.lang.String uri, java.lang.String prefix)` This method is used when a prefix/uri namespace mapping is indicated after the element was started with a startElement() and before and endElement().
`void` | `notationDecl(java.lang.String arg0, java.lang.String arg1, java.lang.String arg2)`
`boolean` | `reset()`
`void` | `setDoctype(java.lang.String doctypeSystem, java.lang.String doctypePublic)` Set the value coming from the xsl:output doctype-public and doctype-system stylesheet properties
`void` | `setDoctypePublic(java.lang.String doctypePublic)` Set the value coming from the xsl:output doctype-public stylesheet attribute.
`void` | `setDoctypeSystem(java.lang.String doctypeSystem)` Set the value coming from the xsl:output doctype-system stylesheet attribute.
`void` | `setDocumentLocator(Locator locator)` Receive an object for locating the origin of SAX document events.
`void` | `setDTDEntityExpansion(boolean expand)` If set to false the serializer does not expand DTD entities, but leaves them as is, the default value is true.
`void` | `setEncoding(java.lang.String encoding)` Sets the character encoding coming from the xsl:output encoding stylesheet attribute.
`void` | `setIndent(boolean doIndent)` Sets the value coming from the xsl:output indent stylesheet attribute.
`void` | `setIndentAmount(int m_indentAmount)` Sets the indentation amount.
`void` | `setMediaType(java.lang.String mediaType)` Sets the value coming from the xsl:output media-type stylesheet attribute.
`void` | `setNamespaceMappings(NamespaceMappings mappings)` Used only by TransformerSnapshotImpl to restore the serialization to a previous state.
`void` | `setOmitXMLDeclaration(boolean b)` Sets the value coming from the xsl:output omit-xml-declaration stylesheet attribute
`void` | `setOutputProperty(java.lang.String name, java.lang.String val)` Set the value for the output property, typically from an xsl:output element, but this does not change what the default value is.
`void` | `setOutputPropertyDefault(java.lang.String name, java.lang.String val)` Set the default value for an output property, but this does not impact any explicitly set value.
`void` | `setSourceLocator(SourceLocator locator)` This method is used to set the source locator, which might be used to generated an error message.
`void` | `setStandalone(java.lang.String standalone)` Sets the value coming from the xsl:output standalone stylesheet attribute.
`void` | `setTransformer(Transformer t)` Sets the transformer associated with this serializer
`void` | `setVersion(java.lang.String version)` Sets the value coming from the xsl:output version attribute.
`void` | `startDocument()` Receive notification of the beginning of a document.
`void` | `unparsedEntityDecl(java.lang.String arg0, java.lang.String arg1, java.lang.String arg2, java.lang.String arg3)`
`void` | `warning(SAXParseException exc)`

Methods inherited from class java.lang.Object
`equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### PKG_NAME

    public static final java.lang.String PKG_NAME

  The name of the package that this class is in.

  Not a public API.

### PKG_PATH

    public static final java.lang.String PKG_PATH

  The same as the name of the package that this class is in except that '.' are replaced with '/'.

  Not a public API.

Method Detail

### comment

    public void comment(java.lang.String data)
                 throws SAXException

  Receive notification of a comment.
  See Also:
    `ExtendedLexicalHandler.comment(String)`

### setDocumentLocator

    public void setDocumentLocator(Locator locator)

  Receive an object for locating the origin of SAX document events.
  Parameters:
    `locator` - An object that can return the location of any SAX document event. Receive an object for locating the origin of SAX document events.

    SAX parsers are strongly encouraged (though not absolutely required) to supply a locator: if it does so, it must supply the locator to the application by invoking this method before invoking any of the other methods in the DocumentHandler interface.

    The locator allows the application to determine the end position of any document-related event, even if the parser is not reporting an error. Typically, the application will use this information for reporting its own errors (such as character content that does not match an application's business rules). The information returned by the locator is probably not sufficient for use with a search engine.

    Note that the locator will return correct information only during the invocation of the events in this interface. The application should not attempt to use it at any other time.

### addAttribute

    public void addAttribute(java.lang.String uri,
                             java.lang.String localName,
                             java.lang.String rawName,
                             java.lang.String type,
                             java.lang.String value,
                             boolean XSLAttribute)
                      throws SAXException

  Adds the given attribute to the set of collected attributes , but only if there is a currently open element. An element is currently open if a startElement() notification has occured but the start of the element has not yet been written to the output. In the stream case this means that we have not yet been forced to close the elements opening tag by another notification, such as a character notification.
  Parameters:
    `uri` - the URI of the attribute
    `localName` - the local name of the attribute
    `rawName` - the qualified name of the attribute
    `type` - the type of the attribute (probably CDATA)
    `value` - the value of the attribute
    `XSLAttribute` - true if this attribute is coming from an xsl:attriute element
  See Also:
    `ExtendedContentHandler.addAttribute(String, String, String, String, String)`

### addAttributeAlways

    public boolean addAttributeAlways(java.lang.String uri,
                                      java.lang.String localName,
                                      java.lang.String rawName,
                                      java.lang.String type,
                                      java.lang.String value,
                                      boolean XSLAttribute)

  Adds the given attribute to the set of attributes, even if there is no currently open element. This is useful if a SAX startPrefixMapping() should need to add an attribute before the element name is seen.
  Parameters:
    `uri` - the URI of the attribute
    `localName` - the local name of the attribute
    `rawName` - the qualified name of the attribute
    `type` - the type of the attribute (probably CDATA)
    `value` - the value of the attribute
    `XSLAttribute` - true if this attribute is coming from an xsl:attribute element
  Returns:
    true if the attribute was added, false if an existing value was replaced.

### addAttribute

    public void addAttribute(java.lang.String name,
                             java.lang.String value)

  Adds the given attribute to the set of collected attributes, but only if there is a currently open element.
  Parameters:
    `name` - the attribute's qualified name
    `value` - the value of the attribute

### addXSLAttribute

    public void addXSLAttribute(java.lang.String name,
                                java.lang.String value,
                                java.lang.String uri)

  Adds the given xsl:attribute to the set of collected attributes, but only if there is a currently open element.
  Parameters:
    `name` - the attribute's qualified name (prefix:localName)
    `value` - the value of the attribute
    `uri` - the URI that the prefix of the name points to

### addAttributes

    public void addAttributes(Attributes atts)
                       throws SAXException

  Add the given attributes to the currently collected ones. These attributes are always added, regardless of whether on not an element is currently open.
  Parameters:
    `atts` - List of attributes to add to this list

### asContentHandler

    public ContentHandler asContentHandler()
                                    throws java.io.IOException

  Return a `ContentHandler` interface into this serializer. If the serializer does not support the `ContentHandler` interface, it should return null.
  Returns:
    A `ContentHandler` interface into this serializer, or null if the serializer is not SAX 2 capable
  Throws:
    java.io.IOException - An I/O exception occured

### endEntity

    public void endEntity(java.lang.String name)
                   throws SAXException

  Report the end of an entity.
  Parameters:
    `name` - The name of the entity that is ending.
  Throws:
    SAXException - The application may raise an exception.
  See Also:
    `LexicalHandler.startEntity(java.lang.String)`

### close

    public void close()

  Flush and close the underlying java.io.Writer. This method applies to ToStream serializers, not ToSAXHandler serializers.
  Specified by:
    close in interface SerializationHandler
  See Also:
    `ToStream`

### getEncoding

    public java.lang.String getEncoding()

  Returns the character encoding to be used in the output document.
  Returns:
    the character encoding to be used in the output document.

### setEncoding

    public void setEncoding(java.lang.String encoding)

  Sets the character encoding coming from the xsl:output encoding stylesheet attribute.
  Parameters:
    `m_encoding` - the character encoding

### setOmitXMLDeclaration

    public void setOmitXMLDeclaration(boolean b)

  Sets the value coming from the xsl:output omit-xml-declaration stylesheet attribute
  Parameters:
    `b` - true if the XML declaration is to be omitted from the output document.

### getOmitXMLDeclaration

    public boolean getOmitXMLDeclaration()

  Returns:
    true if the XML declaration is to be omitted from the output document.

### getDoctypePublic

    public java.lang.String getDoctypePublic()

  Returns the previously set value of the value to be used as the public identifier in the document type declaration (DTD).
  Returns:
    the public identifier to be used in the DOCTYPE declaration in the output document.

### setDoctypePublic

    public void setDoctypePublic(java.lang.String doctypePublic)

  Set the value coming from the xsl:output doctype-public stylesheet attribute.
  Parameters:
    `doctypePublic` - the public identifier to be used in the DOCTYPE declaration in the output document.

### getDoctypeSystem

    public java.lang.String getDoctypeSystem()

  Returns the previously set value of the value to be used as the system identifier in the document type declaration (DTD).
  Returns:
    the system identifier to be used in the DOCTYPE declaration in the output document.

### setDoctypeSystem

    public void setDoctypeSystem(java.lang.String doctypeSystem)

  Set the value coming from the xsl:output doctype-system stylesheet attribute.
  Parameters:
    `doctypeSystem` - the system identifier to be used in the DOCTYPE declaration in the output document.

### setDoctype

    public void setDoctype(java.lang.String doctypeSystem,
                           java.lang.String doctypePublic)

  Set the value coming from the xsl:output doctype-public and doctype-system stylesheet properties
  Parameters:
    `doctypeSystem` - the system identifier to be used in the DOCTYPE declaration in the output document.
    `doctypePublic` - the public identifier to be used in the DOCTYPE declaration in the output document.

### setStandalone

    public void setStandalone(java.lang.String standalone)

  Sets the value coming from the xsl:output standalone stylesheet attribute.
  Parameters:
    `standalone` - a value of "yes" indicates that the `standalone` delaration is to be included in the output document. This method remembers if the value was explicitly set using this method, verses if the value is the default value.

### getStandalone

    public java.lang.String getStandalone()

  Gets the XSL standalone attribute
  Returns:
    a value of "yes" if the `standalone` delaration is to be included in the output document.
  See Also:
    `XSLOutputAttributes.getStandalone()`

### getIndent

    public boolean getIndent()

  Returns:
    true if the output document should be indented to visually indicate its structure.

### getMediaType

    public java.lang.String getMediaType()

  Gets the mediatype the media-type or MIME type associated with the output document.
  Returns:
    the mediatype the media-type or MIME type associated with the output document.

### getVersion

    public java.lang.String getVersion()

  Gets the version of the output format.
  Returns:
    the version of the output format.

### setVersion

    public void setVersion(java.lang.String version)

  Sets the value coming from the xsl:output version attribute.
  Parameters:
    `version` - the version of the output format.
  See Also:
    `XSLOutputAttributes.setVersion(String)`

### setMediaType

    public void setMediaType(java.lang.String mediaType)

  Sets the value coming from the xsl:output media-type stylesheet attribute.
  Parameters:
    `mediaType` - the non-null media-type or MIME type associated with the output document.
  See Also:
    `OutputKeys.MEDIA_TYPE`, `XSLOutputAttributes.setMediaType(String)`

### getIndentAmount

    public int getIndentAmount()

  Returns:
    the number of spaces to indent for each indentation level.

### setIndentAmount

    public void setIndentAmount(int m_indentAmount)

  Sets the indentation amount.
  Specified by:
    setIndentAmount in interface SerializationHandler
  Parameters:
    `m_indentAmount` - The m_indentAmount to set

### setIndent

    public void setIndent(boolean doIndent)

  Sets the value coming from the xsl:output indent stylesheet attribute.
  Parameters:
    `doIndent` - true if the output document should be indented to visually indicate its structure.
  See Also:
    `XSLOutputAttributes.setIndent(boolean)`

### namespaceAfterStartElement

    public void namespaceAfterStartElement(java.lang.String uri,
                                           java.lang.String prefix)
                                    throws SAXException

  This method is used when a prefix/uri namespace mapping is indicated after the element was started with a startElement() and before and endElement(). startPrefixMapping(prefix,uri) would be used before the startElement() call.
  Parameters:
    `uri` - the URI of the namespace
    `prefix` - the prefix associated with the given URI.
  See Also:
    `ExtendedContentHandler.namespaceAfterStartElement(String, String)`

### asDOMSerializer

    public DOMSerializer asDOMSerializer()
                                  throws java.io.IOException

  Return a `DOMSerializer` interface into this serializer. If the serializer does not support the `DOMSerializer` interface, it should return null.
  Returns:
    A `DOMSerializer` interface into this serializer, or null if the serializer is not DOM capable
  Throws:
    java.io.IOException - An I/O exception occured
  See Also:
    `Serializer.asDOMSerializer()`

### getNamespaceMappings

    public NamespaceMappings getNamespaceMappings()

  Some users of the serializer may need the current namespace mappings
  Returns:
    the current namespace mappings (prefix/uri)
  See Also:
    `ExtendedContentHandler.getNamespaceMappings()`

### getPrefix

    public java.lang.String getPrefix(java.lang.String namespaceURI)

  Returns the prefix currently pointing to the given URI (if any).
  Parameters:
    `namespaceURI` - the uri of the namespace in question
  Returns:
    a prefix pointing to the given URI (if any).
  See Also:
    `ExtendedContentHandler.getPrefix(String)`

### getNamespaceURI

    public java.lang.String getNamespaceURI(java.lang.String qname,
                                            boolean isElement)

  Returns the URI of an element or attribute. Note that default namespaces do not apply directly to attributes.
  Parameters:
    `qname` - a qualified name
    `isElement` - true if the qualified name is the name of an element.
  Returns:
    returns the namespace URI associated with the qualified name.

### getNamespaceURIFromPrefix

    public java.lang.String getNamespaceURIFromPrefix(java.lang.String prefix)

  Returns the URI of prefix (if any)
  Parameters:
    `prefix` - the prefix whose URI is searched for
  Returns:
    the namespace URI currently associated with the prefix, null if the prefix is undefined.

### entityReference

    public void entityReference(java.lang.String name)
                         throws SAXException

  Entity reference event.
  Parameters:
    `name` - Name of entity
  Throws:
    SAXException -

### setTransformer

    public void setTransformer(Transformer t)

  Sets the transformer associated with this serializer
  Specified by:
    setTransformer in interface SerializationHandler
  Parameters:
    `t` - the transformer associated with this serializer.
  See Also:
    `SerializationHandler.setTransformer(Transformer)`

### getTransformer

    public Transformer getTransformer()

  Gets the transformer associated with this serializer
  Specified by:
    getTransformer in interface SerializationHandler
  Returns:
    returns the transformer associated with this serializer.
  See Also:
    `SerializationHandler.getTransformer()`

### characters

    public void characters(Node node)
                    throws SAXException

  This method gets the nodes value as a String and uses that String as if it were an input character notification.
  Parameters:
    `node` - the Node to serialize
  Throws:
    SAXException -

### error

    public void error(SAXParseException exc)
               throws SAXException

  See Also:
    `ErrorHandler.error(SAXParseException)`

### fatalError

    public void fatalError(SAXParseException exc)
                    throws SAXException

  See Also:
    `ErrorHandler.fatalError(SAXParseException)`

### warning

    public void warning(SAXParseException exc)
                 throws SAXException

  See Also:
    `ErrorHandler.warning(SAXParseException)`

### fireEndEntity

    public void fireEndEntity(java.lang.String name)
                       throws SAXException

  To fire off end entity trace event
  Parameters:
    `name` - Name of entity

### startDocument

    public void startDocument()
                       throws SAXException

  Receive notification of the beginning of a document. This method is never a self generated call, but only called externally.

  The SAX parser will invoke this method only once, before any other methods in this interface or in DTDHandler (except for setDocumentLocator).

  Throws:
    SAXException - Any SAX exception, possibly wrapping another exception.
    SAXException -

### setSourceLocator

    public void setSourceLocator(SourceLocator locator)

  This method is used to set the source locator, which might be used to generated an error message.
  Parameters:
    `locator` - the source locator
  See Also:
    `ExtendedContentHandler.setSourceLocator(javax.xml.transform.SourceLocator)`

### setNamespaceMappings

    public void setNamespaceMappings(NamespaceMappings mappings)

  Used only by TransformerSnapshotImpl to restore the serialization to a previous state.
  Specified by:
    setNamespaceMappings in interface SerializationHandler
  Parameters:
    `mappings` - NamespaceMappings

### reset

    public boolean reset()

### addAttribute

    public void addAttribute(java.lang.String uri,
                             java.lang.String localName,
                             java.lang.String rawName,
                             java.lang.String type,
                             java.lang.String value)
                      throws SAXException

  This method adds an attribute the the current element, but should not be used for an xsl:attribute child.
  See Also:
    `ExtendedContentHandler.addAttribute(java.lang.String, java.lang.String, java.lang.String, java.lang.String, java.lang.String)`

### notationDecl

    public void notationDecl(java.lang.String arg0,
                             java.lang.String arg1,
                             java.lang.String arg2)
                      throws SAXException

  See Also:
    `DTDHandler.notationDecl(java.lang.String, java.lang.String, java.lang.String)`

### unparsedEntityDecl

    public void unparsedEntityDecl(java.lang.String arg0,
                                   java.lang.String arg1,
                                   java.lang.String arg2,
                                   java.lang.String arg3)
                            throws SAXException

  See Also:
    `DTDHandler.unparsedEntityDecl(java.lang.String, java.lang.String, java.lang.String, java.lang.String)`

### setDTDEntityExpansion

    public void setDTDEntityExpansion(boolean expand)

  If set to false the serializer does not expand DTD entities, but leaves them as is, the default value is true.
  Specified by:
    setDTDEntityExpansion in interface SerializationHandler

### documentIsEmpty

    public boolean documentIsEmpty()

  Return true if nothing has been sent to this result tree yet.

  This is not a public API.

  Usage:
    **For internal use only**

### getOutputProperty

    public java.lang.String getOutputProperty(java.lang.String name)

  Get the value of an output property, the explicit value, if any, otherwise the default value, if any, otherwise null.

### getOutputPropertyNonDefault

    public java.lang.String getOutputPropertyNonDefault(java.lang.String name)

  Get the value of an output property, not the default value. If there is a default value, but no non-default value this method will return null.

### asDOM3Serializer

    public java.lang.Object asDOM3Serializer()
                                      throws java.io.IOException

  Return a `DOM3Serializer` interface into this serializer. If the serializer does not support the `DOM3Serializer` interface, it should return null.
  Returns:
    A `DOM3Serializer` interface into this serializer, or null if the serializer is not DOM capable
  Throws:
    java.io.IOException - An I/O exception occured
  See Also:
    `Serializer.asDOM3Serializer()`

### getOutputPropertyDefault

    public java.lang.String getOutputPropertyDefault(java.lang.String name)

  Get the default value of an xsl:output property, which would be null only if no default value exists for the property.

### setOutputProperty

    public void setOutputProperty(java.lang.String name,
                                  java.lang.String val)

  Set the value for the output property, typically from an xsl:output element, but this does not change what the default value is.

### setOutputPropertyDefault

    public void setOutputPropertyDefault(java.lang.String name,
                                         java.lang.String val)

  Set the default value for an output property, but this does not impact any explicitly set value.

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2006 Apache XML Project. All Rights Reserved.